use std::cmp;
use std::io;

use rand;
use rand::rngs;
use rand::Rng;

fn main()
{
    println!("Guess the number!");

    let mut thread_rng: rngs::ThreadRng = rand::thread_rng();

    let secret_number : u32 = thread_rng.gen_range(1..=100);

    loop
    {
        println!("Please input your guess.");

        let mut guess_string : String = String::new();

        io::stdin().read_line(&mut guess_string).expect("Failed to read line");

        let guess_number : u32 = match guess_string.trim().parse()
        {
            Ok(number) => number,
            Err(_)          => continue
        };

        println!("You guessed : {}", guess_number);

        match guess_number.cmp(&secret_number)
        {
            cmp::Ordering::Less    => println!("Too small!"),
            cmp::Ordering::Greater => println!("Too big!"),
            cmp::Ordering::Equal   =>
            {
                println!("You win!");

                break;
            }
        }
    }
}